/*
 * Copyright (C) 1990,1991 by CERN/CN/SW/DC
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)newacct.c	1.2 11/17/93  CERN CN-SW/DC Antoine Trannoy";
#endif /* not lint */

/* newacct		Command to change current account	*/

#include <stdio.h>
#if !defined(apollo)
#include <unistd.h>
#endif
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <pwd.h>

extern char * ypgetacct() ; 

static void setacct(pwd,account)
	struct passwd    * pwd ;
	char 	     * account ;
{
	extern int    putenv() ; 
	extern char * getenv() ; 
	char        strenv[16] ;
	char shell[MAXPATHLEN] ;
	char 		  * cp ; 

	(void) sprintf(strenv,"ACCOUNT=%s",account) ; 
	if ( putenv(strenv) ) {
		(void) fprintf(stderr,"newacct: unsufficient space to expand the environment\n") ;
		exit(1) ; 
	}
	if ( ( cp= getenv("SHELL")) == NULL ) 
		cp= pwd->pw_shell ;

	(void) strcpy(shell,cp) ; 	 
	if ( (cp= strrchr(cp,'/')) == NULL ) 
		cp ++ ; 
	execl(shell,cp,0) ;
	(void) fprintf(stderr,"newacct: %s not found\n",shell) ; 
	exit(1) ; 
}

main(argc,argv)
	int     argc ; 
	char ** argv ; 
{
	char        buffer[80] ;
	FILE 		  * fp ; 
	struct passwd    * pwd ;
	char 	     * account ; 

	/*
	 * Checking arguments
	 * Setting account.
	 */
	if ( argc > 2 ) {
		(void) fprintf(stderr,"usage is: newacct [accountid] \n") ; 
		exit(1) ; 
	}
	if ( argc > 1 && (int)strlen(argv[1]) > 8 ) {
		(void) fprintf(stderr,"newacct:  invalid account id specified\n") ; 
		exit(1) ; 
	}
	account= ( argc == 1 ) ? NULL : argv[1] ;	

	/*
	 * Getting password entry.
	 */
	if ( (pwd= getpwuid(getuid())) == NULL ) {
		(void) fprintf(stderr,"newacct: who are you ?\n") ; 
		exit(1) ; 
	} 

	/*
	 * Opening account file.
	 */
	if ( (fp= fopen("/etc/account","r")) == NULL ) {
#if defined(NIS)
		char      * cp ; 

		cp= ypgetacct(pwd,account,buffer) ; 
		if ( cp == NULL ) {
			(void) fprintf(stderr,"newacct: invalid account id specified\n") ;
			exit(1) ; 
		}
		else	{
			setacct(pwd,cp) ; 
			/* NOTREACHED	*/
		}
#else
		(void) fprintf(stderr,"newacct: unable to open the account file\n") ; 
		exit(1) ; 
#endif 	/* NIS	*/
	}	

	/*
	 * Parsing /etc/account file.
	 */
	while( fgets(buffer,80,fp) != NULL ) {
		char     * cp ; 

		if ( (cp= strtok(buffer,":")) == NULL ) {
			(void) fprintf(stderr,"newacct: invalid account file\n") ;
			exit(1) ; 
		} 
#if defined(NIS)
		if ( *cp == '+' ) {
			(void) fclose(fp) ;
			cp= ypgetacct(pwd,account,buffer) ; 
			if ( cp == NULL ) {
				fprintf(stderr,"newacct: invalid account id specified\n") ;
				exit(1) ; 
			}
			else	{
				setacct(pwd,cp) ; 
				/* NOTREACHED	*/
			}
		}	
#endif	/* NIS	*/

		if ( strcmp(cp,pwd->pw_name) )  
			continue ;

		if ( (cp= strtok((char *)NULL,":")) == NULL ) { 
			(void) fprintf(stderr,"newacct: invalid account file\n") ;
			exit(1) ; 
		} 

		if ( account == NULL ) {
			char  * seq ; 

			if ( (seq= strtok((char *)NULL,":")) == NULL ) { 
				(void) fprintf(stderr,"newacct: invalid account file\n") ;
				exit(1) ; 
			} 
			if ( atoi(seq) ) 
				continue ;
		}
		else	{
			if ( strcmp(account,cp) ) 
				continue ;
		}

		/*
		 * Setting the new account.
		 */
		(void) fclose(fp) ; 
		setacct(pwd,cp) ; 
		/* NOTREACHED */
	}
	(void) fprintf(stderr,"newacct: invalid account id specified\n") ; 
	(void) fclose(fp) ; 
	exit(1) ; 	
}
