.\" @(#)getacctent.man	1.1 CERN CN-PDP/CS Antony Simmins 06/14/95
.\" Copyright (C) 1995 by CERN CN-PDP/CS
.\" All rights reserved
.\"
.TH GETACCT 3 "30 April 1995"

.SH NAME
.B getacct 
\- get SHIFT account file entry

.SH SYNOPSIS
.B
char *getacct()

.B
char *getacctent(struct passwd *pwd; char *account, char *buffer; int bufferlen)

.SH OVERVIEW
.B Getacct
returns the SHIFT account identifier of the user. It uses the local
copy of the SHIFT account file or the copy held under NIS (Yellow Pages)
if the local file includes the '+' character in the first field of an
account entry.

.SH ENVIRONMENT
.B Getacct
tests for the existence of the variable
.I ACCT_FILE
in the invoking process's environment. If set
.B getacct
uses its value as the absolute pathname of the SHIFT account file on the host.
If not found, the default value
.I "/etc/account"
is used.

.B Getacct
also tests the invoking environment for the variable
.I ACCOUNT.
If set, its value is used as the account identifier to select the possibly
multiple entries for the calling real uid (see account(1) for definitions of
the fields of a SHIFT account file entry). If not set, the default account
for the calling real uid is used (i.e. that account entry with a sequence number
of 0 - see account(1)). The account file uses the username of the calling real uid
as the primary indexing key.

.SH RETURN VALUES
.B Getacct
returns a pointer whose value is either a string containing the required SHIFT account
entry or NULL, indicating any of the following problems: no entry exists for the user,
the user's entry(s) are malformed, no local SHIFT account file could be found, the real uid
has no entry in the password file.

If not NULL, the resulting string should be copied to the calling procedure as subsequent
calls to
.B getacct()
will overwrite it.

.SH ARGUMENT VALUES
.B Getacct
actually calls
.B getacctent
with the passwd entry for the calling real uid and a value for account if the
.I ACCOUNT
environment variable is set, or NULL indicating the default account.

The normal interface is
.B getacct()
but 
.B getacctent()
is also provided for flexibility.

.SH HISTORY
The semantics of getacct are such as to be backwards compatible with its
predecessor of the same name. In particular, the algorithm for using the
NIS (YP) map of the SHIFT account file has been refined to avoid calling
.B yp_all()
unless all other methods of matching the required account file entry fail.
This, hopefully, avoids the bug in
.B yp_all()
whereby the network connection remains open from the client to the NIS (YP)
map server.
