/*
 * Copyright (C) 1990,1991 by CERN/CN/SW/DC
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)fflush.c	3.1 12/06/91 CERN CN-SW/DC Antoine Trannoy";
#endif /* not lint */

/* fflush.c     Remote File I/O - flush a binary file                   */

/*
 * System remote file I/O definitions
 */
#define RFIO_KERNEL     1   
#include "rfio.h"          

/*
 * Remote file flush
 * If the file is remote, this is a dummy operation.
 */
int rfio_fflush(fp)      
	RFILE *fp;             
{
	int     status;

	INIT_TRACE("RFIO_TRACE");
	TRACE(1, "rfio", "rfio_fflush(%x)", fp);

	if ( fp == NULL ) {
		errno = EBADF;
		END_TRACE();
		return -1 ;
	}

	/*
	 * The file is local
	 */
	if ( rfilefdt[fileno((FILE *)fp)] == NULL ) {
		status= fflush((FILE *)fp) ;
		END_TRACE() ; 
		return status ;
	}

	/*
	 * Checking magic number
	 */
	if ( fp->magic != RFIO_MAGIC) {
		serrno = SEBADVERSION ; 
		(void) close(fileno((FILE*)fp)) ;
		rfilefdt[fileno((FILE *)fp)]= NULL ;
		free((char *)fp);
		END_TRACE() ;
		return -1 ;
	}
	END_TRACE();
	return 0 ;
}
