/*
 * Copyright (C) 1990,1991 by CERN/CN/SW/DC
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)lstat.c	1.3 03/01/95 CERN CN-SW/DC Felix Hassine";
#endif /* not lint */

/* lstat.c       Remote File I/O - get file status   */

#define RFIO_KERNEL     1
#include "rfio.h"

static char     buf[256];       /* General input/output buffer          */

int  rfio_lstat(filepath, statbuf)       /* Remote file lstat 		*/
char    *filepath;              	/* remote file path  		*/
struct stat *statbuf;           	/* status buffer 		*/
{
	register int    s;              /* socket descriptor 		*/
	int             lstatus;        /* remote lstat() status    	*/
	int     	len;
	char    	*host, *filename;
	char    	*p=buf;
#if defined(vms)
	unsigned short  unix_st_dev;
	unsigned long   unix_st_ino;
#endif /* vms */
	int 		rt ;

	INIT_TRACE("RFIO_TRACE");
	TRACE(1, "rfio", "rfio_lstat(%s, %x)", filepath, statbuf);

	if (!rfio_parseln(filepath,&host,&filename,NORDLINKS)) {
		/* if not a remote file, must be local  */
		TRACE(1, "rfio", "rfio_lstat: using local lstat(%s, %x)",
			filename, statbuf);

		END_TRACE();
#if !defined(vms)
		return(lstat(filename,statbuf));
#else
		return(stat(filename,statbuf));
#endif /* vms */
	}

	s = rfio_connect(host,&rt);
	if (s < 0)      {
		END_TRACE();
		return(-1);
	}

	len = strlen(filename)+1;
	marshall_WORD(p, RFIO_MAGIC);
	marshall_WORD(p, RQST_LSTAT);
	marshall_LONG(p, len);
	p= buf + RQSTSIZE;
	marshall_STRING(p, filename);
	TRACE(2,"rfio","rfio_lstat: sending %d bytes",RQSTSIZE+len) ;
	if (netwrite(s,buf,RQSTSIZE+len) != RQSTSIZE+len) {
		TRACE(2, "rfio", "rfio_lstat: write(): ERROR occured (errno=%d)", errno);
		(void) netclose(s);
		END_TRACE();
		return(-1);
	}
	p = buf;
	TRACE(2, "rfio", "rfio_lstat: reading %d bytes", 6*LONGSIZE+5*WORDSIZE);
	if (netread(s, buf, 6*LONGSIZE+5*WORDSIZE) != 6*LONGSIZE+5*WORDSIZE)  {
		TRACE(2, "rfio", "rfio_lstat: read(): ERROR occured (errno=%d)", errno);
		(void) netclose(s);
		END_TRACE();
		return(-1);
	}
#if !defined(vms)
	unmarshall_WORD(p, statbuf->st_dev);
	unmarshall_LONG(p, statbuf->st_ino);
#else
	unmarshall_WORD(p, unix_st_dev);
	unmarshall_LONG(p, unix_st_ino);
#endif /* vms */
	unmarshall_WORD(p, statbuf->st_mode);
	unmarshall_WORD(p, statbuf->st_nlink);
	unmarshall_WORD(p, statbuf->st_uid);
	unmarshall_WORD(p, statbuf->st_gid);
	unmarshall_LONG(p, statbuf->st_size);
	unmarshall_LONG(p, statbuf->st_atime);
	unmarshall_LONG(p, statbuf->st_mtime);
	unmarshall_LONG(p, statbuf->st_ctime);
	unmarshall_LONG(p, lstatus);
	TRACE(1, "rfio", "rfio_lstat: return %d",lstatus);
	rfio_errno = lstatus;
	(void) netclose(s);
	if (lstatus)     {
		END_TRACE();
		return(-1);
	}
	END_TRACE();
	return (0);
}
