
/*
 * Copyright (C) 1995-1997 by CERN/CN/SW/DC
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)mstat.c	1.7 08/08/97  CERN CN-SW/DC Felix Hassine";
#endif /* not lint */


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(_WIN32)
#define MAXHOSTNAMELEN 64
#else
#include <sys/param.h>
#endif
#include "log.h"
#define RFIO_KERNEL 1
#include "rfio.h"

static int rfindex = 0 ;
typedef struct socks {
              char host[MAXHOSTNAMELEN];
              int s ;
} connects ;
static connects tab[MAXMCON]; /* UP TO MAXMCON connections simultaneously */
extern int rfio_smstat() ;
static char     buf[256];

int rfio_mstat(file,statb)
char *file ;
struct stat *statb;

{
	
	int rt ,rc ,i ,fd;
	char *host , *filename ;

	if (!rfio_parseln(file,&host,&filename,NORDLINKS)) {
		/* The file is local */
		rc = stat(filename,statb) ;
		return (rc) ;
	}
	else {
		/* Look if already in */
		for ( i=0; i<rfindex; i++ ) {
			if ( !strcmp(host,tab[i].host) ) {
				rc = rfio_smstat(tab[i].s,filename,statb,RQST_MSTAT ) ;
				return ( rc) ;
			}
		}
		fd=rfio_connect(host,&rt) ;
		if ( fd < 0 ) {
			return (-1) ;
		}
		tab[rfindex].s=fd ;
		strcpy( tab[rfindex].host, host) ;
		rfindex++ ;
		if ( rfindex < MAXMCON )
			rc = rfio_smstat(fd,filename,statb,RQST_MSTAT);
		else
			rc = rfio_smstat(fd,filename,statb,RQST_STAT) ;
		return (rc)  ;
	}

}

/* 
 * Simplest operation in stat() : just do a stat() 
 * for 1 filename
 */
rfio_smstat(s,filename,statbuf,reqst) 
int s ;
char * filename ;
struct stat *statbuf ;
int reqst ;

{
	int             status;         /* remote fopen() status        */
	int     len;
	char    *p=buf;

	INIT_TRACE("RFIO_TRACE");
	TRACE(1, "rfio", "rfio_stat(%s, %x)", filename, statbuf);

	len = strlen(filename)+1;
	marshall_WORD(p, RFIO_MAGIC);
	switch ( reqst ) {
		case RQST_MSTAT :
		case RQST_STAT :
			marshall_WORD(p, reqst);
			break ;
		default:
			END_TRACE();
			return (-1) ;
	}
	marshall_LONG(p, len);
	p= buf + RQSTSIZE;
	marshall_STRING(p, filename);
	TRACE(2,"rfio","rfio_stat: sending %d bytes",RQSTSIZE+len) ;
	if (netwrite(s,buf,RQSTSIZE+len) != RQSTSIZE+len) {
		TRACE(2, "rfio", "rfio_stat: write(): ERROR occured (errno=%d)", errno);
		(void) close(s);
		END_TRACE();
		return(-1);
	}
	p = buf;
	TRACE(2, "rfio", "rfio_stat: reading %d bytes", 8*LONGSIZE+5*WORDSIZE);
	if (netread(s, buf, 8*LONGSIZE+5*WORDSIZE) != 8*LONGSIZE+5*WORDSIZE)  {
		TRACE(2, "rfio", "rfio_stat: read(): ERROR occured (errno=%d)", errno);
		(void) close(s);
		END_TRACE();
		return(-1);
	}
	unmarshall_WORD(p, statbuf->st_dev);
	unmarshall_LONG(p, statbuf->st_ino);
	unmarshall_WORD(p, statbuf->st_mode);
	unmarshall_WORD(p, statbuf->st_nlink);
	unmarshall_WORD(p, statbuf->st_uid);
	unmarshall_WORD(p, statbuf->st_gid);
	unmarshall_LONG(p, statbuf->st_size);
	unmarshall_LONG(p, statbuf->st_atime);
	unmarshall_LONG(p, statbuf->st_mtime);
	unmarshall_LONG(p, statbuf->st_ctime);
	unmarshall_LONG(p, status);

	/* 
	 * Inserted here to preserve
	 * backward compatibility with 
	 * former stat () protocol
	 */
#if !defined(_WIN32)
	unmarshall_LONG(p, statbuf->st_blksize);
	unmarshall_LONG(p, statbuf->st_blocks);
#endif

	TRACE(1, "rfio", "rfio_stat: return %d",status);
	rfio_errno = status;
	if (status)     {
		END_TRACE();
		return(-1);
	}
	END_TRACE();
	return (0);

}

int rfio_end()
{
	int i,j=0 ;
	char *p=buf ;
	INIT_TRACE("RFIO_TRACE");
	TRACE(3,"rfio","rfio_end entered\n");
	for ( i=0 ; i< rfindex; i++ )  {
		marshall_WORD(p, RFIO_MAGIC);
        	marshall_WORD(p, RQST_END);
        	marshall_LONG(p, j);
        	if (netwrite(tab[i].s,buf,RQSTSIZE) != RQSTSIZE) {
                	TRACE(2, "rfio", "rfio_stat: write(): ERROR occured (errno=%d)", errno);
                	END_TRACE();
                	return(-1);
		}
               	(void) close(tab[i].s);
        }
        END_TRACE();
	rfindex=0 ;
}

