/*
 * Copyright (C) 1994-1997 by CERN/CN/PDP/CS
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)rfcp.c	1.17 08/29/97 CERN CN-PDP/CS Felix Hassine ";
#endif /* not lint */

#include <fcntl.h>
#define RFIO_KERNEL 1
#include <rfio.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifndef TRANSFER_UNIT
#define TRANSFER_UNIT    32768
#endif
#if !defined(vms)
#define SYERR 2
#define USERR 1
#define OK    0
#else
#define SYERR 2*2
#define USERR 1*2
#define OK    1
#endif  /* vms */

extern int errno;
extern int serrno ;
extern int rfio_errno ;
extern char *sys_errlist[];
extern char *getconfent() ;

#if defined(vms) && (vms == 1)
#include <unixio.h>
#if !defined(S_ISDIR)
#define S_ISDIR(m)	(((m)&S_IFMT) == S_IFDIR)
#endif /* S_ISDIR */
#if !defined(S_ISCHR)
#define S_ISCHR(m)	(((m)&S_IFMT) == S_IFCHR)
#endif /* S_ISCHR */
#if !defined(S_ISBLK)
#define S_ISBLK(m) 	(((m)&S_IFMT) == S_IFBLK)
#endif /* S_ISBLK */
#define	unlink	delete
#endif /* vms */
#if defined(_WIN32)
#define S_ISDIR(m)  (((m)&S_IFMT) == S_IFDIR)
#define S_ISCHR(m)  (((m)&S_IFMT) == S_IFCHR)
#endif

main(argc, argv)
int argc;
char *argv[];
{
  int c;
  int  fd1, fd2;
  struct stat sbuf, sbuf2;
  long   starttime, endtime, size;
  int rc ;
  struct stat statbuf ;
  char filename[128] ;
  char *cp , *ifce ;
  char ifce1[8] ;
  char ifce2[8] ;
  char *host1, *host2, *path1, *path2 ;
  char shost1[32];
  int l1, l2 ;
  extern char * getifnam() ;
#if defined(_WIN32)
  WSADATA wsadata;
#endif

  	if (argc < 3) usage();
 /* Check that files are not identical ! */

#if defined(_WIN32)
	if (WSAStartup (MAKEWORD (2, 0), &wsadata)) {
		fprintf (stderr, "WSAStartup unsuccessful\n");
		exit (SYERR);
	}
#endif
	l1 = rfio_parseln( argv[1] , &host1, &path1, NORDLINKS ) ;
	if ( l1 ) 
		strcpy(shost1,host1) ;
	strcpy( filename, path1 );

	l2 = rfio_parseln( argv[2] , &host2, &path2, NORDLINKS ) ;

	if ( ( l1 == 0 && l2 == 0 && !strcmp(filename,path2) ) ||
	     (  host2 != NULL && !strcmp( shost1, host2 ) && !strcmp( filename, path2) ) ) {
		printf("files are identical \n");
#if defined(_WIN32)
		WSACleanup();
#endif
		exit (OK) ;
	}

  /* Command is of the form cp f1 f2. */
  	serrno = 0 ;
  	rfio_errno = 0 ;
  	fd1 = rfio_open(argv[1],O_RDONLY ,0644);
  	if (fd1 < 0) {
         	if (serrno) {
                        rfio_perror(argv[1]);
                        c = SYERR;
         	}
         	else
                   switch (rfio_errno) {
                        case EACCES:
                        case EISDIR:
                        case ENOENT:
                        case EPERM :
                                rfio_perror(argv[1]);
                                c = USERR;
                                break ;
                        case 0:
                                switch(errno) {
                                        case EACCES:
                                        case EISDIR:
                                        case ENOENT:
                                        case EPERM :
                                                rfio_perror(argv[1]);
                                                c = USERR;
                                                break;
                                        default:
                                                rfio_perror(argv[1]);
                                                c = SYERR;
                                }
                                break;
                        default:
                                rfio_perror(argv[1]);
                                c = SYERR;
          	 }
#if defined(_WIN32)
			WSACleanup();
#endif
			exit (c);
  	}
	if ( (ifce=getifnam(fd1))==NULL ) 
                strcpy(ifce1,"local");
        else
                strcpy(ifce1,ifce) ;
	rc = rfio_fstat(fd1, &sbuf);
	if ( rc == 0 && ( S_ISDIR(sbuf.st_mode) || S_ISCHR(sbuf.st_mode)
#if !defined(_WIN32)
		|| S_ISBLK(sbuf.st_mode)
#endif
								) ) {
		fprintf(stderr,"file %s: Not a regular file\n",argv[1]);
		rfio_close(fd1) ;
#if defined(_WIN32)
		WSACleanup();
#endif
		exit(USERR) ;
	}
	if ( rfio_stat( argv[2], &statbuf) == 0 &&  
		S_ISDIR(statbuf.st_mode) &&
		( cp = strrchr(argv[1],'/') ) != NULL  ) {
		sprintf(filename, "%s/%s", argv[2], cp +1);
	}
	else
		strcpy(filename,argv[2]) ;

        serrno = 0 ;
        rfio_errno = 0 ;

	fd2 = rfio_open(filename , O_WRONLY|O_CREAT|O_TRUNC ,sbuf.st_mode & 0777);
	if (fd2 < 0) {
		if (serrno) {
			rfio_perror(argv[2]);
			c = SYERR;
		}
		else
		   switch (rfio_errno) {
			case EACCES:
			case EISDIR:
			case ENOENT:
			case EPERM :
				rfio_perror(argv[2]); 
				c = USERR;
				break;
			case 0:
				switch(errno) {
					case EACCES:
					case EISDIR:
					case ENOENT:
					case EPERM :
						rfio_perror(argv[2]); 
						c = USERR;
						break;
					default:
						rfio_perror(argv[2]);
						c = SYERR;
				}
				break;
			default:
				rfio_perror(argv[2]);
				c = SYERR;
		   }
#if defined(_WIN32)
		WSACleanup();
#endif
		exit (c);
	}
	/*
	 * Get interfaces names
	 */
	if ( (ifce=getifnam(fd2))==NULL ) 
                strcpy(ifce2,"local");
        else
                strcpy(ifce2,ifce) ;

	rfio_fstat(fd2, &sbuf2);
	time(&starttime);
	size = copyfile(fd1, fd2, argv[2]);
	time(&endtime);
	if (size>0)  {
		fprintf(stdout,"%d bytes in %d seconds through %s (in) and %s (out)",size, endtime-starttime,ifce1,ifce2);
		l1 = endtime-starttime ;
		if ( l1 > 0) {
			fprintf(stdout," (%d KB/sec)\n",size/(1024*l1) );
		}
		else    {
			fprintf(stdout,"\n");
		}
	}
	else    {
		fprintf(stdout,"%d bytes transferred !!\n",size);
	}
#if defined(_WIN32)
  WSACleanup();
#endif
  exit(OK);
}

copyfile(fd1, fd2, name)
int fd1, fd2;
char *name;
{
  int n, m, mode;
  struct stat sbuf;
  int totsize;
  int effsize=0;
  char  *p;
  int bufsize = TRANSFER_UNIT;
  char * cpbuf;
  extern char *getenv();		/* External declaration */


  if (rfio_fstat(fd1,&sbuf) <0)      {
	perror("unable to stat");
#if defined(_WIN32)
	WSACleanup();
#endif
	exit(SYERR);
  }

  if ((p=getenv("RFCPBUFSIZ")) == NULL) {
	if ((p=getconfent("RFCP","BUFFERSIZE",0)) == NULL) {
	      bufsize=TRANSFER_UNIT;
	} else  {
	      bufsize=atoi(p);
	}
  } else {
	bufsize=atoi(p);
  }
  if (bufsize<=0) bufsize=TRANSFER_UNIT;

  if ( ( cpbuf = malloc(bufsize) ) == NULL ) {
	perror("malloc");
#if defined(_WIN32)
	WSACleanup();
#endif
	exit (SYERR);
  }

  totsize = sbuf.st_size;
  do {
	n = rfio_read(fd1, cpbuf, bufsize);
	if (n > 0) {
		effsize += n;
		totsize -= n;
		m = rfio_write(fd2, cpbuf, n);
		if (m != n) {
			/* Write failed.  Don't keep truncated regular file. */
			rfio_perror("cp");
			rfio_fstat(fd2, &sbuf);	/* check for special files */
			mode = sbuf.st_mode & S_IFMT;
			if (mode == S_IFREG) rfio_unlink(name);
#if defined(_WIN32)
			WSACleanup();
#endif
			exit(SYERR);
		}
	} else {
		if (n < 0) {
			rfio_perror("cp: read error");
			break;
		}
		if (n == 0)     {
			break;
		}
	}
  } while (totsize > 0);
  rfio_close(fd1);
  rfio_close(fd2);
  return(effsize);
}

usage()
{
  fprintf(stderr,"Usage:  rfcp f1 f2; or rfcp f1 <dir2>\n");
  exit(USERR);
}
