/*
 * Copyright (C) 1990-1997 by CERN/CN/SW/DC
 * All rights reserved
 */

#ifndef lint
static char sccsid[] = "@(#)rfstatfs.c	1.6 09/24/97  CERN CN-SW/DC Felix Hassine";
#endif /* not lint */

#define RFIO_KERNEL 1
#include <sys/param.h>
#if defined(SOLARIS)
#include <sys/types.h>
#include <sys/statvfs.h>
#endif
#if defined(_AIX)
#include <sys/types.h>
#endif
#if defined(sgi) || (defined( _AIX ) && defined( _IBMR2) ) 
#include <sys/statfs.h>
#endif
#if (defined(_AIX) && defined(_IBMESA)) || (defined(__osf__) && defined(__alpha))
#include <sys/mount.h>
#endif
#if (defined( sun ) && !defined(SOLARIS)) || defined( hpux ) || defined(linux)
#include <sys/vfs.h>
#endif
#if defined(ultrix)
#include <sys/types.h>
#include <sys/param.h>
#include <sys/mount.h>
#endif
#include <rfio.h>

int rfstatfs(path, statfsbuf )
char *path ;
struct rfstatfs *statfsbuf ;
{
	int status = 0   ;

#if defined( ultrix )
        struct fs_data fsbuffer;
#else
#if defined( SOLARIS )
	static struct statvfs fsbuffer ;
#else
        static struct statfs fsbuffer;
#endif
#endif
#if defined(__osf__) && defined(__alpha)
            if ( statfs(path,&fsbuffer,(int)sizeof(struct statfs)) < 0) {
                status = -1;
            }
#endif
#if defined( cray ) || defined( apollo ) || defined( sgi )
            if ( statfs(path,&fsbuffer,(int)sizeof(struct statfs),(int)0) < 0) {
                status = -1;
            }
#endif
#if ( defined( sun ) && !defined(SOLARIS) ) || defined( _AIX ) || defined( hpux ) || defined(linux)
            if ( statfs(path,&fsbuffer) < 0 ) {
                status = -1;
            }
#endif
#if defined( ultrix )
            if ( statfs(path,&fsbuffer) < 1 ) {
                status = -1;
            }
#endif
#if defined ( SOLARIS )
	    if (statvfs (  path, &fsbuffer ) < 0) {
		status = -1;
	    }
#endif

        /*
         * Affecting variables
         */

	if  ( status == 0 ) {
#if defined( ultrix )
           statfsbuf->bsize = (long)1024;
           statfsbuf->totblks = (long)fsbuffer.fd_req.btot;
           statfsbuf->freeblks = (long)fsbuffer.fd_req.bfreen;
           statfsbuf->freenods = (long)fsbuffer.fd_req.gfree ;
           statfsbuf->totnods = (long)fsbuffer.fd_req.gtot ;
#endif
#if defined( sgi )
           statfsbuf->freeblks = (long)fsbuffer.f_bfree;
           statfsbuf->bsize = (long)fsbuffer.f_bsize ;
           statfsbuf->totblks = (long)fsbuffer.f_blocks;
           statfsbuf->totnods = (long)fsbuffer.f_files ;
           statfsbuf->freenods = (long)fsbuffer.f_ffree ;
#endif
#if defined(SOLARIS)
           statfsbuf->freeblks = (long)fsbuffer.f_bfree;
           statfsbuf->bsize = (long)fsbuffer.f_frsize ;
           statfsbuf->totblks = (long)fsbuffer.f_blocks;
           statfsbuf->totnods = (long)fsbuffer.f_files ;
           statfsbuf->freenods = (long)fsbuffer.f_ffree ;
#endif
#if (defined( sun ) && !defined(SOLARIS) ) || defined( hpux ) || defined( _AIX ) || defined(linux)
           statfsbuf->totblks = (long)fsbuffer.f_blocks;
           statfsbuf->freeblks = (long)fsbuffer.f_bavail;
           statfsbuf->totnods = (long)fsbuffer.f_files ;
           statfsbuf->freenods = (long)fsbuffer.f_ffree ;
           statfsbuf->bsize = (long)fsbuffer.f_bsize;
#endif
#if defined(__osf__) && defined(__alpha)
           statfsbuf->totblks = (long)fsbuffer.f_blocks;
           statfsbuf->freeblks = (long)fsbuffer.f_bavail;
           statfsbuf->totnods = (long)fsbuffer.f_files ;
           statfsbuf->freenods = (long)fsbuffer.f_ffree ;
           statfsbuf->bsize = (long)fsbuffer.f_fsize ;
#endif
 	}
	return status ;

}

