.\" @(#)sysreqd.man	1.1     CERN CN-SW/DC Frederic Hemmer 08/10/91
.\" Copyright (C) 1990,1991 by CERN/CN/SW/DC
.\" All rights reserved
.\"
.TH SYSREQD l "08/10/91"
.SH NAME
sysreqd \- sysreq daemon
.SH SYNOPSIS
.B sysreqd
.I [-t protocol]
.I [-h hostname]
.I [-p port]
.SH DESCRIPTION
.IX "\fLsysreqd\fR"
.IX  tcp
.IX  sysreq
sysreqd start the daemon handling sysreq requests.
.SH OPTIONS
.TP
.B \-t protocol
Specify the protocol services. It defaults to tcp. Currently only tcp is
supported.
.TP
.B \-h hostname
Hostname on which the daemon will listen. This is useful when multiple
interfaces are attached to the host. \fIhostname\fP is protocol dependent.
.TP
.B \-p port
Local port number on which to listen. Only for the tcp protocol.
This overcome the services(5) \fBsysreq\fP entry
.TP
.B \-d
Debug mode. Print verbose messages.
.SH OVERRIDING DEFAULTS
Some environment variables allows defaults overriding.
The general processing for options is as follows.
Environment variables have more precedence than option switches.
Options switches have more precedence than the /etc/sysreqrc file.
/etc/sysreqrc has more precedence than system defaults (e.g. services(5)
entries) which in turn has more precedence than built-in defaults.
.TP
.B \fBSYSREQ_HOST\fP
send request to the specified host
.TP
.B \fBSYSREQ_PORT\fP
use this port instead of the default one
.TP
.B \fBSYSREQ_TRACE\fP
print verbose debug messages. Equivalent to the -d switch
.SH "SEE ALSO"
sysreq(1), services(5), tcp(4), sysreqrc(8)
.SH "AUTHOR"
Frederic Hemmer, CERN-CN Division CH-1211 Geneva 23, Switzerland
(hemmer@cernvm.cern.ch)
