.\" @(#)tpinfo.man	1.3 03/28/97 CERN CN-PDP/DH Jean-Philippe Baud
.\" Copyright (C) 1994-1997 by CERN/CN/PDP/DH
.\" All rights reserved
.\"
.TH TPINFO l "03/28/97"
.SH NAME
tpinfo \- get tape file information from header labels and mount requests;
get also the tape drive name.
.SH SYNOPSIS
.B tpinfo
.BI -P " path_name"
.SH DESCRIPTION
.B tpinfo
prints on standard output the main characteristics of a tape file
as an option string.
If a labelled tape is read and options are not set on the
.B tpmnt
command,  values are taken from the header labels.
The file id is of course only available for labelled tapes.
This command prints also the name and the type of the drive where the tape is
currently mounted and the density used (if known).
.SH OPTIONS
.TP
.BI \-P " pathname"
Specifies the pathname relative to the current directory or the full pathname
which is used by the application program in the OPEN statement.
.SH EXAMPLES
.nf
	tpmnt -P test -v AB1234
	tpinfo -P test
would report
	-b 32760 -F F -f TSTDATA -L 32760 -q 1 -D cart0F9C -T 3480
.fi
.SH RETURN CODES
\ 
.br
0	Ok.
.br
2	No such file.
.br
200	Tape daemon is not running.
.br
201	System or communication error.
.br
203	Bad parameter.
